'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

exports.default = function (options) {
  var WORKINGDIR = options.root;

  var test = function test(file) {
    return file.endsWith('.js');
  };

  return function () {
    var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(ctx, next) {
      var OUTPUTFILE, compiler, memoryFs, status, result;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(ctx.method === 'GET' && ctx.accepts(CONTENT_TYPE) && test(ctx.path) && ctx.query.transpile !== 'false')) {
                _context.next = 23;
                break;
              }

              OUTPUTFILE = 'output.js';


              ctx.type = CONTENT_TYPE;

              _context.prev = 3;
              _context.next = 6;
              return (0, _configureBundler2.default)({
                devtool: options.devtool,
                root: options.root,
                entry: [_path2.default.join('.', ctx.path)],
                output: OUTPUTFILE,
                production: false
              });

            case 6:
              compiler = _context.sent;
              memoryFs = new _memoryFs2.default();


              compiler.outputFileSystem = memoryFs;

              _context.next = 11;
              return (0, _runCompilerAsync2.default)(compiler);

            case 11:
              status = _context.sent;
              result = status.toJson();

              if (!result.errors.length) {
                _context.next = 15;
                break;
              }

              throw result.errors;

            case 15:
              _context.next = 17;
              return (0, _readFileAsync2.default)(memoryFs, _path2.default.join(WORKINGDIR, OUTPUTFILE));

            case 17:
              ctx.body = _context.sent;
              _context.next = 23;
              break;

            case 20:
              _context.prev = 20;
              _context.t0 = _context['catch'](3);

              ctx.body = (0, _formatError2.default)(_context.t0);

            case 23:
              _context.next = 25;
              return next();

            case 25:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this, [[3, 20]]);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();
};

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _memoryFs = require('memory-fs');

var _memoryFs2 = _interopRequireDefault(_memoryFs);

var _readFileAsync = require('./read-file-async');

var _readFileAsync2 = _interopRequireDefault(_readFileAsync);

var _runCompilerAsync = require('./run-compiler-async');

var _runCompilerAsync2 = _interopRequireDefault(_runCompilerAsync);

var _formatError = require('./format-error');

var _formatError2 = _interopRequireDefault(_formatError);

var _configureBundler = require('./configure-bundler');

var _configureBundler2 = _interopRequireDefault(_configureBundler);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var CONTENT_TYPE = 'application/javascript';
//# sourceMappingURL=quik-middleware-js.js.map